package cc3002.library;

import cc3002.library.visitor.Visitor;

public class Book extends LibraryItem {

	public Book(String name, String author, int year, String publisher) {
		super(name, author, year);
		this.setPublisher(publisher);
	}
	
	@Override 
	public boolean equals(Object object) {
		if (object instanceof Book)
		{
			Book anotherBook = (Book) object;
			return this.getName().equals(anotherBook.getName()) && 
				   this.getAuthor().equals(anotherBook.getAuthor()) && 	
				   this.getYear() == (anotherBook.getYear()) && 
				   this.getPublisher().equals(anotherBook.getPublisher());
		} else return false;
	}

	public void setPublisher(String publisher) {
		this.publisher = publisher;
	}

	public String getPublisher() {
		return publisher;
	}

	public void accept (Visitor visitor) {
		visitor.visitBook(this);
	}
	
	private String publisher;
}
