package cc3002.library;

import java.util.Vector;

import cc3002.checker.AuthorChecker;
import cc3002.library.visitor.Visitor;

public class Library {
	Folder folder;
	
	public Library() {
		folder = new Folder("root", "UChile", 1876);
		folder.addItem(new Book("The Book Of Questions", "Neruda", 2001, "Copper Canyon Press"));
		folder.addItem(new Book("Artificial Paradises", "Baudelaire", 1998, "Citadel"));
		
		Folder newFolder = new Folder("Guillaume Apollinaire's collection", "Guillaume Apollinaire", 1971);
		newFolder.addItem(new Book("Selected Writings", "Guillaume Apollinaire", 1971, "New Directions Publishing Corporation"));
		newFolder.addItem(new Book("Calligrammes: Poems of Peace and War", "Guillaume Apollinaire", 2004, "University of California Press"));
		folder.addItem(newFolder);
	}

	public Folder root() {
		return folder;
	}

	public void run(Visitor visitor) {
		this.root().accept(visitor);
	}

	public Vector<LibraryItem> searchByAuthors(String string) {
		SearchVisitor searchVisitor = 
			new SearchVisitor (new AuthorChecker (string));
		this.root().accept(searchVisitor);
		return searchVisitor.getResult();
	}
}
