package cc3002.library;

import java.util.Vector;

import cc3002.checker.Checker;
import cc3002.library.visitor.Visitor;

public class SearchVisitor extends Visitor {
	private Checker checker;
	Vector<LibraryItem> result = new Vector<LibraryItem> ();

	public Vector<LibraryItem> getResult() {
		return result;
	}

	public SearchVisitor(Checker checker) {
		super();
		this.checker = checker;
	}

	@Override
	public void visitBook(Book book) {
		if (checker.check(book)) result.add(book);
	}

	@Override
	public void visitFolder(Folder folder) {
		if (checker.check(folder)) result.add(folder);
	}

	@Override
	public void visitNewspaper(Newspaper newspaper) {
		if (checker.check(newspaper)) result.add(newspaper);
	}
	

}
