package cc3002.test;

import static org.junit.Assert.*;
import static org.junit.Assert.assertTrue;

import java.util.Vector;

import org.junit.Before;
import org.junit.Test;

import cc3002.checker.AuthorChecker;
import cc3002.checker.Checker;
import cc3002.checker.YearChecker;
import cc3002.library.Book;
import cc3002.library.Library;
import cc3002.library.LibraryItem;
import cc3002.library.visitor.CountingVisitor;


public class LibraryTest {
	private Library library;
	
	@Before public void setUp () {
		library = new Library();
	}
	
	@Test public void libraryRoot () {
		assertTrue (library.root() != null);
	}

	@Test public void bookCounting () {
		CountingVisitor counter = new CountingVisitor();
		library.run(counter);
		assertEquals (counter.numberOfItems(), 6);
	}
	
	@Test public void bookCounting2() {
		BookCountingVisitor counter = new BookCountingVisitor();
		library.run(counter);
		assertEquals (counter.numberOfBooks(), 4);
	}
	
	@Test public void checker () {
		Book aBook = new Book("Extreme Programming Explained", "Kent Beck", 2004, "Addison-Wesley Professional");
		Checker checker1 = new AuthorChecker("Kent Beck");
		Checker checker2 = new YearChecker(2004);
		assertTrue (checker1.check(aBook));
		assertTrue (checker2.check(aBook));
	}
	
	@Test public void searchingBook() {
		Vector<LibraryItem> searchedItems = library.searchByAuthors("Guillaume Apollinaire");
		assertEquals(searchedItems.size(), 3);
	}
}
